/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-webcomponents-core";
import { StringBuilder } from "igniteui-webcomponents-core";
import { stringIsNullOrEmpty } from "igniteui-webcomponents-core";
import { isNaN_ } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let IconVisualModelExport = /*@__PURE__*/ (() => {
    class IconVisualModelExport extends Base {
        constructor() {
            super(...arguments);
            this.i = 0;
            this.g = 0;
            this.f = 0;
            this.j = 0;
            this.a = null;
            this.b = null;
            this.d = null;
            this.c = null;
            this.e = 0;
            this._svgPath = null;
            this._svg = null;
            this.k = null;
            this.q = null;
            this.r = null;
            this.s = null;
            this.h = 0;
            this.o = null;
            this.p = null;
        }
        get svgPath() {
            return this._svgPath;
        }
        set svgPath(a) {
            this._svgPath = a;
        }
        get svg() {
            return this._svg;
        }
        set svg(a) {
            this._svg = a;
        }
        l() {
            let a = new StringBuilder(0);
            a.l("{");
            a.l("shapes: [");
            if (this.a != null && this.a.length > 0) {
                for (let b = 0; b < this.a.length; b++) {
                    let c = this.a[b].serialize();
                    a = b < this.a.length - 1 ? a.l(c + ", ") : a.l(c);
                }
            }
            a.u("], ");
            a.l("top : " + this.i + ", ");
            a.l("left : " + this.g + ", ");
            a.l("height : " + this.f + ", ");
            a.l("width : " + this.j + ", ");
            a.l("svg : \"" + this.svg + "\", ");
            a.l("svgPath : \"" + this.svgPath + "\", ");
            a.l("dataURL : \"" + this.k + "\", ");
            if (!stringIsNullOrEmpty(this.q)) {
                a.l("textStyleFontStyle : \"" + this.q + "\", ");
            }
            if (!stringIsNullOrEmpty(this.r)) {
                a.l("textStyleFontVariant : \"" + this.r + "\", ");
            }
            if (!stringIsNullOrEmpty(this.s)) {
                a.l("textStyleFontWeight : \"" + this.s + "\", ");
            }
            if (!stringIsNullOrEmpty(this.o)) {
                a.l("textStyleFontFamily : \"" + this.o + "\", ");
            }
            if (!stringIsNullOrEmpty(this.p)) {
                a.l("textStyleFontStretch : \"" + this.p + "\", ");
            }
            if (!isNaN_(this.h)) {
                a.l("textStyleFontSize : " + this.h + ", ");
            }
            a.l("}");
            return a.toString();
        }
    }
    IconVisualModelExport.$t = /*@__PURE__*/ markType(IconVisualModelExport, 'IconVisualModelExport');
    return IconVisualModelExport;
})();
