import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { XInputGroupItem } from "./XInputGroupItem";
export declare abstract class IgcXInputGroupItemComponent extends IgcHTMLElement {
    protected createImplementation(): XInputGroupItem;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): XInputGroupItem; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgcXInputGroupItemComponent;
    private onImplementationCreated;
    constructor();
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcXInputGroupItemComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    /**
     * Gets or sets name to use for the button.
    */
    get name(): string;
    set name(v: string);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
}
