/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { XComponentBridge } from "./XComponentBridge";
import { runOn, delegateCombine, delegateRemove, enumGetBox, EnumUtil, markType } from "igniteui-webcomponents-core";
import { NativeUICheckboxChangeEventArgs } from "igniteui-webcomponents-core";
import { BaseControlTheme_$type } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let XCheckboxBridge = /*@__PURE__*/ (() => {
    class XCheckboxBridge extends XComponentBridge {
        constructor(a) {
            super(a);
            this.u = null;
            this.v = null;
        }
        addHandler(a, b, c, d) {
            let e = a;
            switch (c) {
                case 2:
                    let f = a;
                    e.change = delegateCombine(e.change, runOn(this, this.w));
                    this.u = d;
                    this.v = b;
                    break;
            }
        }
        removeHandler(a, b, c, d) {
            let e = a;
            switch (c) {
                case 2:
                    e.change = delegateRemove(e.change, runOn(this, this.w));
                    this.u = null;
                    this.v = null;
                    break;
            }
        }
        w(a, b) {
            if (this.u != null) {
                let c = new NativeUICheckboxChangeEventArgs();
                this.u(this.v, c);
            }
        }
        getValue(a, b) {
            let c = a;
            switch (b) {
                case 4: return c.y;
                case 7: return c.checked;
                case 18: return enumGetBox(BaseControlTheme_$type, c.n);
                case 17: return c.ar;
                case 65: return c.dl;
                case 67: return c.dm;
                case 66: return c.dd;
                case 68: return c.de;
            }
            return null;
        }
        setValue(a, b, c) {
            let d = a;
            switch (b) {
                case 4:
                    d.y = c;
                    return;
                case 7:
                    d.checked = c;
                    return;
                case 18:
                    d.n = EnumUtil.getEnumValue(BaseControlTheme_$type, c);
                    break;
                case 17:
                    d.ar = c;
                    break;
                case 65:
                    d.dl = c;
                    break;
                case 67:
                    d.dm = c;
                    break;
                case 66:
                    d.dd = c;
                    break;
                case 68:
                    d.de = c;
                    break;
            }
        }
        exportVisualData(a) {
            return a.a3();
        }
    }
    XCheckboxBridge.$t = /*@__PURE__*/ markType(XCheckboxBridge, 'XCheckboxBridge', XComponentBridge.$);
    return XCheckboxBridge;
})();
