import { CheckboxChangeEventArgs as CheckboxChangeEventArgs_internal } from "./CheckboxChangeEventArgs";
import { ensureBool } from "igniteui-webcomponents-core";
var IgcCheckboxChangeEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgcCheckboxChangeEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgcCheckboxChangeEventArgs.prototype.createImplementation = function () {
        return new CheckboxChangeEventArgs_internal();
    };
    Object.defineProperty(IgcCheckboxChangeEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcCheckboxChangeEventArgs.prototype.onImplementationCreated = function () {
    };
    IgcCheckboxChangeEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgcCheckboxChangeEventArgs.prototype, "isChecked", {
        get: function () {
            return this.i.isChecked;
        },
        set: function (v) {
            this.i.isChecked = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcCheckboxChangeEventArgs.prototype, "isIndeterminate", {
        get: function () {
            return this.i.isIndeterminate;
        },
        set: function (v) {
            this.i.isIndeterminate = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgcCheckboxChangeEventArgs;
}());
export { IgcCheckboxChangeEventArgs };
