import { __extends } from "tslib";
import { IgCollection } from "igniteui-webcomponents-core";
import { markType } from "igniteui-webcomponents-core";
import { SyncableObservableCollection$2 } from "igniteui-webcomponents-core";
import { XInputGroupItem as XInputGroupItem_internal } from './XInputGroupItem';
import { IgcXInputGroupItemComponent as IgcXInputGroupItemComponent } from './igc-x-input-group-item-component';
var IgcXInputGroupInputCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcXInputGroupInputCollection, _super);
    function IgcXInputGroupInputCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgcXInputGroupItemComponent.$type) {
            IgcXInputGroupItemComponent.$type = markType(IgcXInputGroupItemComponent, "IgcXInputGroupItemComponent");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgcXInputGroupInputCollection.prototype._createInnerColl = function () {
        if (!IgcXInputGroupItemComponent.$type) {
            IgcXInputGroupItemComponent.$type = markType(IgcXInputGroupItemComponent, "IgcXInputGroupItemComponent");
        }
        var coll = new SyncableObservableCollection$2(IgcXInputGroupItemComponent.$type, XInputGroupItem_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgcXInputGroupItemComponent._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgcXInputGroupInputCollection;
}(IgCollection));
export { IgcXInputGroupInputCollection };
